//using System;
//using System.Collections;
//using System.ComponentModel;
//using System.Data;
//using System.Drawing;
//using System.Web;
//using System.Net;
//using System.Web.Services;
//using System.Web.SessionState;
//using System.Web.UI;
//using System.Web.UI.WebControls;
//using System.Web.UI.HtmlControls;
//using System.Data.SqlClient;
//using System.Security.Cryptography;
//using System.Web.Security;
//using System.Xml;
//using System.Configuration;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.IdentityModel.Clients.ActiveDirectory;
using System.Threading.Tasks;
using System.Net.Http;
using System.Collections.Specialized;
using System.Web.Security;
//using System.IdentityModel.Tokens;
using System.Net;
using System.IO;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace PBIWebApp
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public partial class Login : System.Web.UI.Page
	{

		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
      
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    

		}
		#endregion

  

		protected void BtnLogon_Click(object sender, System.EventArgs e)
		{
			string userID = TxtUser.Text;
			bool userAuthenticated = false;

            // TODO: Authenticate user against a profile store

			try
			{
                Session["user"] = userID;
                Session["redirectUrl"] = FormsAuthentication.GetRedirectUrl(userID, false);
                bool bypassPowerBILogin = Properties.Settings.Default.BypassPowerBILogin;
                if (bypassPowerBILogin)
                {
                // As it stands, Power BI doesn't support custom security so the user must be registered with Power BI
                // After you authenticate the user, you need to retrieve the Power BI user credentials 
                string powerBIUserID = Properties.Settings.Default.PowerBIUserID;
                System.Security.SecureString powerBIPassword = Util.DecryptString(Properties.Settings.Default.PowerBIPassword);

                // perform two-leg OAuth
                   System.Net.WebRequest request = System.Net.WebRequest.Create("https://login.microsoftonline.com/e7b81d0a-a949-4103-83dc-feff6277c109/oauth2/token") as System.Net.HttpWebRequest;
                   request.ContentType = "application/x-www-form-urlencoded";
                   request.Method = WebRequestMethods.Http.Post;
                   using (StreamWriter streamWriter = new StreamWriter(request.GetRequestStream()))
                   {
                       string payload = String.Format("grant_type=password&client_id={0}&client_secret={1}&resource=https%3a%2f%2fanalysis.windows.net%2fpowerbi%2fapi&username={2}&password={3}", 
                           WebUtility.UrlEncode(Properties.Settings.Default.ClientID), WebUtility.UrlEncode(Properties.Settings.Default.ClientSecret),
                           WebUtility.UrlEncode(powerBIUserID), WebUtility.UrlEncode(Util.ToInsecureString(powerBIPassword)));
                       streamWriter.Write(payload);
                   }
                   using (HttpWebResponse response = (HttpWebResponse)request.GetResponse())
                   {
                       using (StreamReader streamReader = new StreamReader(response.GetResponseStream()))
                       {
                           string payload = streamReader.ReadToEnd();
                           payload = payload.Replace("access_token", "AccessToken");
                           payload = payload.Replace("refresh_token", "RefreshToken");

                           AuthenticationResult ar = AuthenticationResult.Deserialize(payload);
                           Session["authResult"] = ar;
                       }
                   }
                }
                else
                {
                    //perform three-leg OAuth
                    string authorityUri = "https://login.windows.net/common/oauth2/authorize/";
                    //Create a query string
                    //Create a sign-in NameValueCollection for query string
                    var @params = new NameValueCollection
                    {
                        //Azure AD will return an authorization code. 
                        //See the Redirect class to see how "code" is used to AcquireTokenByAuthorizationCode
                        {"response_type", "code"},

                        //Client ID is used by the application to identify themselves to the users that they are requesting permissions from. 
                        //You get the client id when you register your Azure app.
                        {"client_id", Properties.Settings.Default.ClientID},

                        //Resource uri to the Power BI resource to be authorized
                        {"resource", "https://analysis.windows.net/powerbi/api"},

                        //After user authenticates, Azure AD will redirect back to the web app http://localhost:13528/Redirect
                        {"redirect_uri", String.Format("{0}://{1}/Redirect", HttpContext.Current.Request.Url.Scheme, 
                            HttpContext.Current.Request.Url.Authority)}
                    };
                    FormsAuthentication.RedirectFromLoginPage(userID, false);
                    //Create sign-in query string
                    var queryString = HttpUtility.ParseQueryString(string.Empty);
                    queryString.Add(@params);
                    Response.Redirect(String.Format("{0}?{1}", authorityUri, queryString));   
                }

                userAuthenticated = true; // user is authenticated

			}
			catch(Exception ex)
			{
				lblMessage.Text = ex.Message;
				return;
			}
            if (userAuthenticated == true)
			{
				lblMessage.Text = "Logon successful: User is authenticated";
				FormsAuthentication.RedirectFromLoginPage(userID, false);
			}
			else
			{
				lblMessage.Text = "Invalid username or password";
			}
		}

	}


}
